sphere.vertices := (segments+1)*(segments+1);
sphere.faces := segments*segments*2;

getmem(sphere.vertex,sphere.vertices*sizeof(vector));
getmem(sphere.face,sphere.faces*sizeof(_face));
getmem(sphere.normal,sphere.faces*sizeof(vector));

for i2 := 0 to segments do 
for i := 0 to segments do
	begin
	sphere.vertex[i2*(segments+1)+i].x := sin(i*(360/segments)*pi/180)*sin(i2*(180/segments)*pi/180);
	sphere.vertex[i2*(segments+1)+i].y := cos(i*(360/segments)*pi/180)*sin(i2*(180/segments)*pi/180);
	sphere.vertex[i2*(segments+1)+i].z := cos(i2*(180/segments)*pi/180);
	end;

for i2 := 0 to (segments-1) do 
 for i := 0 to (segments-1) do
	begin
	sphere.face[i2*segments*2+i*2].a := i    		+i2*(segments+1);
	sphere.face[i2*segments*2+i*2].b := (i+1)  	+i2*(segments+1);
	sphere.face[i2*segments*2+i*2].c := i+(segments+1) 	+i2*(segments+1);

	sphere.face[i2*segments*2+i*2+1].a := i+1  +i2*(segments+1);
	sphere.face[i2*segments*2+i*2+1].b := i+(segments+2) +i2*(segments+1);
	sphere.face[i2*segments*2+i*2+1].c := i+(segments+1) +i2*(segments+1);
	end;

glcalcnormal(sphere);

