Procedure RenderPart1(timer:single);
begin


glclear($4100);
GlOrthoIdent;
glcolor3f(0.2,0.2,0.23);
gldisable(gl_texture_2d);
drawsprite(0,0,1,1);


glclear($100);


cameraposition.x := 90.01;
cameraposition.y := 0;
cameraposition.z := 0;
cameratarget.x :=0;
cameratarget.y :=0;
cameratarget.z :=0;


lpos[0] := 8;
lpos[1] := 0;
lpos[2] := 0;

gllightfv(gl_light0,gl_position,@lpos[0]);

glenable(gl_lighting);
glenable(gl_light0);

glShadeModel(GL_SMOOTH);									// Select Smooth Shading
glMateriali(GL_FRONT, GL_SHININESS, 128);



glmatrixmode(gl_projection);
glloadidentity;
gluPerspective(45,4/3,0.01,400);


glulookat(
cameraposition.x,cameraposition.y,cameraposition.z,
cameratarget.x,cameratarget.y,cameratarget.z,0,0,1);

glrotatef(-30+timer/100,1,0,0);
glrotatef(timer/100,0,1,0);

for i := -16 to 16 do
for i2 := 0 to 35 do
begin
glmatrixmode(gl_modelview);
glloadidentity;
amp := 8+abs(20*sin((i*12+timer)*pi/180));



glrotatef(i2*10,0,0,1);

gltranslatef(amp,0,i*3);


glcolor3f(1,1,1);
glenable(gl_depth_test);
gldrawbox;
end;

gldisable(gl_lighting);
gldisable(gl_light0);

cp.x := cameraposition.x;
cp.y := cameraposition.y;
cp.z := cameraposition.z;
ct.x := cameratarget.x;
ct.y := cameratarget.y;
ct.z := cameratarget.z;


NewParticle(
random(10)-5,random(10)-5,40,
0,0,-1,
0,0,1,
1,24,cp,ct);

NewParticle(
random(4)-2,random(4)-2,40,
0,0,-1.2,
1,1,1,
1,8,cp,ct);

  glBlendFunc( gl_one,gl_one );


{$I RenderParticles.i}

glclear($100);
glorthoident;

glenable(gl_blend);
glblendfunc(gl_one,gl_one);
gldisable(gl_depth_test);
glbindtexture(gl_texture_2d,texts[0]);

glcolor3f(0.5,0.5,0.5);
drawsprite(0.7,-0.9,0.5+sin(timer*pi/180)/80,0.1+sin(timer*pi/180)/80);
drawsprite(0.7,-0.9,0.5+cos(timer*pi/180)/80,0.1+cos(timer*pi/180)/80);


gldisable(gl_blend);
glenable(gl_depth_test);
end;


procedure RenderPart2(timer:single);
begin

p := particles;

if firsttimepart1 then 
begin
repeat
   p:= p[0].next;
   p[0].power :=0;
until p[0].next= nil;    
firsttimepart1 := false;
end;


glclear($4100);
GlOrthoIdent;
glcolor3f(0.2,0.2,0.23);
gldisable(gl_texture_2d);
drawsprite(0,0,1,1);
glclear($100);


cameraposition.x := 40.01;
cameraposition.y := 0.7-timer/40000;
cameraposition.z := 1.7;
cameratarget.x :=0;
cameratarget.y :=0;
cameratarget.z :=0;


//lpos[0] := cameraposition.x-;
lpos[0] := 0;
lpos[1] := cameraposition.y-40;
lpos[2] := cameraposition.z+3;

gllightfv(gl_light0,gl_position,@lpos[0]);

glenable(gl_lighting);
glenable(gl_light0);

glShadeModel(GL_SMOOTH);									// Select Smooth Shading
glMateriali(GL_FRONT, GL_SHININESS, 128);


glmatrixmode(gl_projection);
glloadidentity;
gluPerspective(45,4/3,0.01,1400);

glulookat(
cameraposition.x,cameraposition.y,cameraposition.z,
cameratarget.x,cameratarget.y,cameratarget.z,0,0,1);


cp.x := cameraposition.x;
cp.y := cameraposition.y;
cp.z := cameraposition.z;
ct.x := cameratarget.x;
ct.y := cameratarget.y;
ct.z := cameratarget.z;


glmatrixmode(gl_modelview);
glloadidentity;
glscalef(180,2,1);
glenable(gl_depth_test);
glcolor3f(1,1,1);
gldrawbox;



for i := 1 to 40 do
begin
glcolor3f(0.1,0.1,0.1);
glmatrixmode(gl_modelview);
glloadidentity;
gltranslatef( (round(sav1[i] + timer/5) mod 4000 - 2000)/10,-1.5,1.1);
glscalef(0.5,0.25,0.13);
gldrawbox;

NewParticle((round(sav1[i] + timer/5) mod 4000 - 2000)/10 +0.6,-1.6 ,1.1,
0,0,0,1,1,1,0,0.5,cp,ct);
   
NewParticle((round(sav1[i] + timer/5) mod 4000 - 2000)/10 +0.6,-1.4 ,1.1,
0,0,0,1,1,1,0,0.5,cp,ct);

end;



for i := 1 to 40 do
begin
glcolor3f(0.1,0.1,0.1);
glmatrixmode(gl_modelview);
glloadidentity;
gltranslatef( (round(sav2[i] + timer/5) mod 4000 - 2000)/10,-0.5,1.1);
glscalef(0.5,0.25,0.13);
gldrawbox;

NewParticle((round(sav2[i] + timer/5) mod 4000 - 2000)/10 +0.6,-0.6 ,1.1,
0,0,0,1,1,1,0,0.5,cp,ct);
   
NewParticle((round(sav2[i] + timer/5) mod 4000 - 2000)/10 +0.6,-0.4 ,1.1,
0,0,0,1,1,1,0,0.5,cp,ct);

end;



for i := 1 to 40 do
begin
glcolor3f(0.1,0.1,0.1);
glmatrixmode(gl_modelview);
glloadidentity;
gltranslatef( (4000-round(sav3[i] + timer/5) mod 4000 - 2000)/10,0.5,1.1);
glscalef(0.5,0.25,0.13);
gldrawbox;

NewParticle((4000-round(sav3[i] + timer/5) mod 4000 - 2000)/10 +0.6,0.6 ,1.1,
0,0,0,1,0,0,0,0.5,cp,ct);
   
NewParticle((4000-round(sav3[i] + timer/5) mod 4000 - 2000)/10 +0.6,0.4 ,1.1,
0,0,0,1,0,0,0,0.5,cp,ct);

end;


for i := 1 to 40 do
begin
glcolor3f(0.1,0.1,0.1);
glmatrixmode(gl_modelview);
glloadidentity;
gltranslatef( (4000-round(sav4[i] + timer/5) mod 4000 - 2000)/10,1.5,1.1);
glscalef(0.5,0.25,0.13);
gldrawbox;

NewParticle((4000-round(sav4[i] + timer/5) mod 4000 - 2000)/10 +0.6,1.6 ,1.1,
0,0,0,1,0,0,0,0.5,cp,ct);
   
NewParticle((4000-round(sav4[i] + timer/5) mod 4000 - 2000)/10 +0.6,1.4 ,1.1,
0,0,0,1,0,0,0,0.5,cp,ct);

end;


for i := 1 to 100 do
for i2 := 0 to 71 do
begin

if (i2 div 9) mod 2 = 0 then 

NewParticle( (round(i*400-20000+timer/4) mod 40000) /100,4*cos((i2*5+timer/100)*pi/180),4*sin((i2*5+timer/100)*pi/180),
0,0,0,1,1,1,0,0.6+random(100)/1000,cp,ct) else

NewParticle( (round(i*400-20000+timer/4) mod 40000) /100,4*cos((i2*5+timer/100)*pi/180),4*sin((i2*5+timer/100)*pi/180),
0,0,0,0.6,0.6,0.6,0,0.6+random(100)/1000,cp,ct);


end;


gldisable(gl_lighting);

glblendfunc( gl_src_color,gl_one_minus_src_color);

{$I RENDERPARTICLES.I}

glclear($100);
glorthoident;

glenable(gl_blend);
glblendfunc(gl_one,gl_one);
gldisable(gl_depth_test);
glbindtexture(gl_texture_2d,texts[2]);

glcolor3f(0.5,0.5,0.5);
drawsprite(0.7,-0.9,0.5+sin(timer/10*pi/180)/80,0.1+sin(timer/10*pi/180)/80);
drawsprite(0.7,-0.9,0.5+cos(timer/10*pi/180)/80,0.1+cos(timer/10*pi/180)/80);


gldisable(gl_blend);
glenable(gl_depth_test);


end; 


Procedure RenderTitle(timer:single);
begin


glclear($4100);
GlOrthoIdent;
glcolor3f(0.2,0.2,0.23);
gldisable(gl_texture_2d);
drawsprite(0,0,1,1);

glclear($100);
glorthoident;

glenable(gl_blend);
glblendfunc(gl_one,gl_one);
gldisable(gl_depth_test);
glenable(gl_texture_2d);
glbindtexture(gl_texture_2d,texts[1]);

glcolor3f(1,1,1);
drawsprite(0,0,0.7,0.07);

gldisable(gl_blend);
glenable(gl_depth_test);

end;


Procedure RenderPart3(timer:single);
begin
glclear($4100);
GlOrthoIdent;
glcolor3f(0.2,0.2,0.23);
gldisable(gl_texture_2d);
drawsprite(0,0,1,1);
glclear($100);

cameraposition.x := sin(timer*pi/18000)*3;
cameraposition.y := cos(timer*pi/18000)*3;
cameraposition.z := 4+sin(timer*pi/18000);
cameratarget.x :=0;
cameratarget.y :=0;
cameratarget.z :=1;


lpos[0] := cameraposition.x;
lpos[1] := cameraposition.y;
lpos[2] := cameraposition.z;

gllightfv(gl_light0,gl_position,@lpos[0]);

glenable(gl_lighting);
glenable(gl_light0);
glenable(gl_normalize);
glenable(gl_depth_test);
glShadeModel(GL_SMOOTH);									// Select Smooth Shading
glMateriali(GL_FRONT, GL_SHININESS, 128);


glmatrixmode(gl_projection);
glloadidentity;
gluPerspective(45,4/3,0.01,400);

glulookat(
cameraposition.x,cameraposition.y,cameraposition.z,
cameratarget.x,cameratarget.y,cameratarget.z,0,0,1);

glmatrixmode(gl_modelview);


kpx := sin(timer*pi/3000);
kpy := cos(timer*pi/2000);

spheresize := 1.1;

for i := 0 to obj2p.vertices-1 do
 begin
  tav := sqrt(sqr(kpx-obj2p.vertex[i].x) + sqr(kpy-obj2p.vertex[i].y))/spheresize;
  if tav <= 1 then 
  dz := 1-sqrt(1-sqr(tav))/2 else dz := 1;
  obj2.vertex[i].z := obj2p.vertex[i].z*dz;
 end;

for i := 0 to obj3p.vertices-1 do
 begin
  tav := sqrt(sqr(kpx-obj3p.vertex[i].x) + sqr(kpy-obj3p.vertex[i].y))/spheresize;
  if tav <= 1 then 
  dz := 1-sqrt(1-sqr(tav))/2 else dz := 1;
  obj3.vertex[i].z := obj3p.vertex[i].z*dz;
 end;

for i := 0 to obj4p.vertices-1 do
 begin
  tav := sqrt(sqr(kpx-obj4p.vertex[i].x) + sqr(kpy-obj4p.vertex[i].y))/spheresize;
  if tav <= 1 then 
  dz := 1-sqrt(1-sqr(tav))/2 else dz := 1;
  obj4.vertex[i].z := obj4p.vertex[i].z*dz;
 end;


for i := 0 to obj5p.vertices-1 do
 begin
  tav := sqrt(sqr(kpx-obj5p.vertex[i].x) + sqr(kpy-obj5p.vertex[i].y))/spheresize;
  if tav <= 1 then 
  dz := 1-sqrt(1-sqr(tav))/2 else dz := 1;
  obj5.vertex[i].z := obj5p.vertex[i].z*dz;
 end;


for i := 0 to obj6p.vertices-1 do
 begin
  tav := sqrt(sqr(kpx-obj6p.vertex[i].x) + sqr(kpy-obj6p.vertex[i].y))/spheresize;
  if tav <= 1 then 
  dz := 1-sqrt(1-sqr(tav))/2 else dz := 1;
  obj6.vertex[i].z := obj6p.vertex[i].z*dz;
 end;


glcalcnormal(obj2);

gldrawobjfaced(obj6);
gldrawobjfaced(obj5);
gldrawobjfaced(obj4);
gldrawobjfaced(obj3);
gldrawobjfaced(obj2);
gldrawobjfaced(obj1);

gldisable(gl_lighting);

for i2 := 0 to 35 do
for i := 0 to 35 do
begin
NewParticle( 
kpx+sin((timer/1000)+i*10*pi/180)*cos(i2*10*pi/180),
kpy+cos((timer/1000)+i*10*pi/180)*cos(i2*10*pi/180),
2.1+sin(i2*10*pi/180),
0,0,0,0.6,0.6,0.6,0,0.1,cp,ct);
end;

glenable(gl_blend);
glblendfunc(gl_one,gl_one);
{$I RENDERPARTICLES.I}


glclear($100);
glorthoident;

glenable(gl_blend);
glblendfunc(gl_one,gl_one);
gldisable(gl_depth_test);
glbindtexture(gl_texture_2d,texts[3]);

glcolor3f(0.5,0.5,0.5);
drawsprite(0.7,-0.9,0.5+sin(timer/10*pi/180)/80,0.1+sin(timer/10*pi/180)/80);
drawsprite(0.7,-0.9,0.5+cos(timer/10*pi/180)/80,0.1+cos(timer/10*pi/180)/80);


gldisable(gl_blend);
glenable(gl_depth_test);


end;

procedure RenderPart4(timer:single);
begin

glclear($4100);
GlOrthoIdent;
glcolor3f(0.2,0.2,0.23);
gldisable(gl_texture_2d);
drawsprite(0,0,1,1);
glclear($100);

cameraposition.x := sin(timer*pi/19000)*(0.4+(timer/60000));
cameraposition.y := cos(timer*pi/19000)*(0.4+(timer/60000));
cameraposition.z := 1-timer/10000;
cameratarget.x :=0;
cameratarget.y :=0;
cameratarget.z :=0;
cameratarget.z :=1-timer/10000;


lpos[0] := cameraposition.x;
lpos[1] := cameraposition.y;
lpos[2] := cameraposition.z;

gllightfv(gl_light0,gl_position,@lpos[0]);

glenable(gl_lighting);
glenable(gl_light0);
glenable(gl_normalize);
glenable(gl_depth_test);
glShadeModel(GL_SMOOTH);									// Select Smooth Shading
glMateriali(GL_FRONT, GL_SHININESS, 128);


glmatrixmode(gl_projection);
glloadidentity;
gluPerspective(45,4/3,0.01,400);

glulookat(
cameraposition.x,cameraposition.y,cameraposition.z,
cameratarget.x,cameratarget.y,cameratarget.z,0,0,1);

glmatrixmode(gl_modelview);
gldisable(gl_blend);
gldrawobj(neni);

gldisable(gl_lighting);


glclear($100);

GlOrthoIdent;
glcolor3f(0.2,0.2,0.23);
gldisable(gl_texture_2d);
drawsprite(0,-0.5,1,0.5);

glclear($100);

glcolor3f(0,0,0);
glenable(gl_blend);
glblendfunc(gl_one,gl_one);
drawsprite(0,0.5,1,0.5);



glcolor3f(0.02,0.01,0.01);

glmatrixmode(gl_projection);
glloadidentity;
gluPerspective(45,4/3,0.01,300);

glulookat(
cameraposition.x,cameraposition.y,cameraposition.z,
cameratarget.x,cameratarget.y,cameratarget.z,0,0,1);

glmatrixmode(gl_modelview);
gldepthmask(gl_false);

gldrawobj(neni);
gldepthmask(gl_true);

for i := 0 to 35 do
begin
NewParticle( 
sin((timer/1000)+i*10*pi/180)/3,
cos((timer/1000)+i*10*pi/180)/3,
1-timer/10000,
0,0,0,1,0,0,0,0.05,cp,ct);

NewParticle( 
sin((timer/1000)+i*10*pi/180)/3,
cos((timer/1000)+i*10*pi/180)/3,
1-timer/10000 ,
0,0,0,1,1,1,0,0.03,cp,ct);

end;

for i := 0 to neni.vertices-1 do
begin

NewParticle( 
neni.vertex[i].x,
neni.vertex[i].y,
neni.vertex[i].z,
0,0,0,0,0,1,0,0.015,cp,ct);

NewParticle( 
neni.vertex[i].x,
neni.vertex[i].y,
neni.vertex[i].z,
0,0,0,1,1,1,0,0.006,cp,ct);

end;

gldisable(gl_depth_test);
glenable(gl_blend);
glblendfunc(gl_one,gl_one);
{$I RENDERPARTICLES.I}


glclear($100);
glorthoident;

glenable(gl_blend);
glblendfunc(gl_one,gl_one);
gldisable(gl_depth_test);
glbindtexture(gl_texture_2d,texts[20]);

glcolor3f(0.5,0.5,0.5);
drawsprite(0.7,-0.9,0.5+sin(timer/10*pi/180)/80,0.1+sin(timer/10*pi/180)/80);
drawsprite(0.7,-0.9,0.5+cos(timer/10*pi/180)/80,0.1+cos(timer/10*pi/180)/80);


gldisable(gl_blend);
glenable(gl_depth_test);


end;


procedure RenderPart5(timer:single);
begin

glclear($4100);
GlOrthoIdent;
glcolor3f(0.2,0.2,0.23);
gldisable(gl_texture_2d);
drawsprite(0,0,1,1);


glclear($100);


cameraposition.x := 40*sin(timer/10*pi/180);
cameraposition.y := 40*cos(timer/10*pi/180);
cameraposition.z := 40;
cameratarget.x :=0;
cameratarget.y :=0;
cameratarget.z :=0;




cameraposition.x := 40*sin(timer/600*pi/180);
cameraposition.y := 40*cos(timer/600*pi/180);
cameraposition.z := 40;

lpos[0] := cameraposition.x;
lpos[1] := cameraposition.y-10;
lpos[2] := cameraposition.z+10;


gllightfv(gl_light0,gl_position,@lpos[0]);

glenable(gl_lighting);
glenable(gl_light0);

glShadeModel(GL_SMOOTH);									// Select Smooth Shading
glMateriali(GL_FRONT, GL_SHININESS, 128);



glmatrixmode(gl_projection);
glloadidentity;
gluPerspective(45,4/3,1,200);

glulookat(
cameraposition.x,cameraposition.y,cameraposition.z,
cameratarget.x,cameratarget.y,cameratarget.z,0,0,1);

glenable(gl_depth_test);


for i := -10 to 10 do
for i2 := -10 to 10 do
for i3 := -10 to 10 do
begin
glmatrixmode(gl_modelview);
glloadidentity;
gltranslatef(i*(9),i2*(9),i3*(9));
gldrawbox;
end;

gldisable(gl_lighting);

glclear($100);
glorthoident;

glcolor3f(0.2,0.2,0.23);
gldisable(gl_texture_2d);
drawsprite(0,0.87,1,0.2);
drawsprite(0,-0.87,1,0.2);


glenable(gl_texture_2d);

glenable(gl_blend);
glblendfunc(gl_one,gl_one);
gldisable(gl_depth_test);
glbindtexture(gl_texture_2d,texts[4]);

glcolor3f(0.5,0.5,0.5);
drawsprite(0.48,-0.9,0.5+sin(timer/10*pi/180)/80,0.1+sin(timer/10*pi/180)/80);
drawsprite(0.48,-0.9,0.5+cos(timer/10*pi/180)/80,0.1+cos(timer/10*pi/180)/80);


gldisable(gl_blend);
glenable(gl_depth_test);

end;


procedure RenderPart6(timer:single);
begin

glclear($4100);
GlOrthoIdent;
glcolor3f(0.2,0.2,0.23);
gldisable(gl_texture_2d);
drawsprite(0,0,1,1);

glclear($100);

cameraposition.x := 6*sin(timer/50*pi/180);
cameraposition.y := 6*cos(timer/50*pi/180);
cameraposition.z := 6*sin(timer/100*pi/180);
cameratarget.x :=0;
cameratarget.y :=0;
cameratarget.z :=0;


lpos[0] := cameraposition.x+2;
lpos[1] := cameraposition.y+2;
lpos[2] := cameraposition.z+2;

gllightfv(gl_light0,gl_position,@lpos[0]);

glenable(gl_lighting);
glenable(gl_light0);
glenable(gl_normalize);
glShadeModel(GL_SMOOTH);									// Select Smooth Shading
glMateriali(GL_FRONT, GL_SHININESS, 128);


glmatrixmode(gl_projection);
glloadidentity;
gluPerspective(45,4/3,0.01,400);


glulookat(
cameraposition.x,cameraposition.y,cameraposition.z,
cameratarget.x,cameratarget.y,cameratarget.z,0,0,1);

glmatrixmode(gl_modelview);

glenable(gl_depth_test);


//gldrawbox;


for i2 := 0 to segments do
 for i := 0 to segments do
  begin
   displace[i2][i]:= 2+(sin((timer/27+ i *(360/segments) )*pi/180))*(cos((timer/34+ i2*(360/segments))*pi/180));
   displace[i2][i]:= displace[i2][i]+(sin((timer/16+ i2*(360/segments))*pi/180));

 end;

cp.x := cameraposition.x;
cp.y := cameraposition.y;
cp.z := cameraposition.z;
ct.x := cameratarget.x;
ct.y := cameratarget.y;
ct.z := cameratarget.z;


for i2 := 0 to segments do
 for i := 0 to segments do
 	begin
	sphere.vertex[i2*(segments+1)+i].x := spherep.vertex[i2*(segments+1)+i].x+ spherep.vertex[i2*(segments+1)+i].x * displace[i2][i];
	sphere.vertex[i2*(segments+1)+i].y := spherep.vertex[i2*(segments+1)+i].y+ spherep.vertex[i2*(segments+1)+i].y * displace[i2][i];
	sphere.vertex[i2*(segments+1)+i].z := spherep.vertex[i2*(segments+1)+i].z+ spherep.vertex[i2*(segments+1)+i].z * displace[i2][i];

	NewParticle(
	sphere.vertex[i2*(segments+1)+i].x*1.06,
	sphere.vertex[i2*(segments+1)+i].y*1.06,
	sphere.vertex[i2*(segments+1)+i].z*1.06,
	0,0,0,
	0.5,0.5,1,
	0,0.2,cp,ct);

	NewParticle(
	sphere.vertex[i2*(segments+1)+i].x*1.06,
	sphere.vertex[i2*(segments+1)+i].y*1.06,
	sphere.vertex[i2*(segments+1)+i].z*1.06,
	0,0,0,
	1,1,1,
	0,0.1,cp,ct);


	end;

glcalcnormal(sphere);

gldrawobjfaced(sphere);

gldisable(gl_lighting);

glenable(gl_blend);
glblendfunc(gl_one,gl_one);

{$I renderparticles.i}

glclear($100);
glorthoident;

glenable(gl_blend);
glblendfunc(gl_one,gl_one);
gldisable(gl_depth_test);
glbindtexture(gl_texture_2d,texts[21]);

glcolor3f(0.5,0.5,0.5);
drawsprite(0.7,-0.9,0.5+sin(timer/10*pi/180)/80,0.1+sin(timer/10*pi/180)/80);
drawsprite(0.7,-0.9,0.5+cos(timer/10*pi/180)/80,0.1+cos(timer/10*pi/180)/80);


gldisable(gl_blend);
glenable(gl_depth_test);
end;

procedure renderpart7(timer : single);
begin


glclear($4100);
GlOrthoIdent;
glcolor3f(0.2,0.2,0.23);
gldisable(gl_texture_2d);
drawsprite(0,0,1,1);

glclear($100);

cameraposition.x := -100;
cameraposition.y := 0;
cameraposition.z := 0;
cameratarget.x :=0;
cameratarget.y :=0;
cameratarget.z :=0;


lpos[0] := cameraposition.x+2;
lpos[1] := cameraposition.y+2;
lpos[2] := cameraposition.z+2;

gllightfv(gl_light0,gl_position,@lpos[0]);

glenable(gl_lighting);
glenable(gl_light0);
glenable(gl_normalize);
glShadeModel(GL_SMOOTH);									// Select Smooth Shading
glMateriali(GL_FRONT, GL_SHININESS, 128);


glmatrixmode(gl_projection);
glloadidentity;
gluPerspective(70,4/3,1,600);


glulookat(
cameraposition.x,cameraposition.y,cameraposition.z,
cameratarget.x,cameratarget.y,cameratarget.z,0,0,1);

glrotatef(timer/100,1,0,0);

glmatrixmode(gl_modelview);

glenable(gl_depth_test);

cp.x := cameraposition.x;
cp.y := cameraposition.y;
cp.z := cameraposition.z;
ct.x := cameratarget.x;
ct.y := cameratarget.y;
ct.z := cameratarget.z;



for i:= 0 to 200 do
begin
glmatrixmode(gl_modelview);
glloadidentity;

gltranslatef(
200+(-round(boxes[i].x*100 + timer*boxspeed[i]/90) mod 10000)/25

,boxes[i].y,boxes[i].z);

	NewParticle(
	1+200+(-round(boxes[i].x*100 + timer*boxspeed[i]/90) mod 10000)/25
	,boxes[i].y,boxes[i].z,
	0,0,0,
	0.1,0.1,0.1,
	0.1,77,cp,ct);


	NewParticle(
	1+200+(-round(boxes[i].x*100 + timer*boxspeed[i]/90) mod 10000)/25
	,boxes[i].y,boxes[i].z,
	0,0,0,
	1,1,1,
	0.15,11,cp,ct);

  
glrotatef(timer/boxspeed[i]*2,0,0,1);
glrotatef(timer/boxspeed[i]*2,0,1,0);
glrotatef(timer/boxspeed[i]*2,1,0,0);

gldrawbox;
end;


gldisable(gl_lighting);
glenable(gl_blend);
glblendfunc(gl_one,gl_one);
{$i renderparticles2.i};

glclear($100);
glorthoident;

glenable(gl_blend);
glblendfunc(gl_one,gl_one);
gldisable(gl_depth_test);
glbindtexture(gl_texture_2d,texts[5]);

glcolor3f(0.5,0.5,0.5);
drawsprite(0.7,-0.9,0.5+sin(timer/10*pi/180)/80,0.1+sin(timer/10*pi/180)/80);
drawsprite(0.7,-0.9,0.5+cos(timer/10*pi/180)/80,0.1+cos(timer/10*pi/180)/80);


gldisable(gl_blend);
glenable(gl_depth_test);

end;

Procedure RenderPart9(timer:single);
begin
glclear($4100);
GlOrthoIdent;
glcolor3f(0.2,0.2,0.23);
gldisable(gl_texture_2d);
drawsprite(0,0,1,1);

glclear($100);
glenable(gl_normalize);

cameraposition.x := 26;//28*cos(-timer*pi/180000);
cameraposition.y := 3*sin(-timer*pi/18000);
cameraposition.z := 3*cos(timer*pi/18000);
cameratarget.x :=0;
cameratarget.y :=0;
cameratarget.z :=0;


lpos[0] := cameraposition.x;
lpos[1] := cameraposition.y;
lpos[2] := cameraposition.z-10;

gllightfv(gl_light0,gl_position,@lpos[0]);

glenable(gl_lighting);
glenable(gl_light0);
glShadeModel(GL_SMOOTH);									// Select Smooth Shading
glMateriali(GL_FRONT, GL_SHININESS, 128);


glmatrixmode(gl_projection);
glloadidentity;
gluPerspective(70,4/3,0.1,50);


glulookat(
cameraposition.x,cameraposition.y,cameraposition.z,
cameratarget.x,cameratarget.y,cameratarget.z,0,0,1);


glmatrixmode(gl_modelview);

glenable(gl_depth_test);
glenable(gl_normalize);

cp.x := cameraposition.x;
cp.y := cameraposition.y;
cp.z := cameraposition.z;
ct.x := cameratarget.x;
ct.y := cameratarget.y;
ct.z := cameratarget.z;

if timer > 7000 then 
shipoffs := (timer -7000)/150;


glmatrixmode(gl_modelview);

for i := 0 to 40 do 
begin
glloadidentity;
gltranslatef(fighter[i].x-shipoffs,fighter[i].y,fighter[i].z);
glscalef(0.3,0.3,0.3);
gldrawobj(vadasz);
	NewParticle(
	fighter[i].x+0.16-shipoffs,
	fighter[i].y+0.1,
	fighter[i].z,
	0.01,0,0,
	1,1,0.2,
	0.2,0.2+random(10)/40,cp,ct);

	NewParticle(
	fighter[i].x+0.16-shipoffs,
	fighter[i].y-0.1,
	fighter[i].z,
	0.01,0,0,
	1,1,0.2,
	0.2,0.2+random(10)/40,cp,ct);

                                    

end;

for i := 0 to 10 do 
begin
glloadidentity;
gltranslatef(destroyer[i*2].x-shipoffs,destroyer[i*2].y,destroyer[i*2].z);
gldrawobj(rombolo);

	NewParticle(
	destroyer[i*2].x+1-shipoffs,
	destroyer[i*2].y-0.31,
	destroyer[i*2].z-0.16,
	0.01,0,0,
	1,1,0.1,
	0.5,0.5+random(10)/40,cp,ct);


	NewParticle(
	destroyer[i*2].x+1-shipoffs,
	destroyer[i*2].y-0.12,
	destroyer[i*2].z-0.16,
	0.01,0,0,
	1,1,0.1,
	0.5,0.5+random(10)/40,cp,ct);


end;


//glloadidentity;
//glscalef(10,10,10);
//gldrawobjfaced(sphere);

blast := 300-timer/20;

if blast > 0 then 
begin

for i := 0 to (sphere.faces div 2)-1 do
begin
x := sphere.normal[i*2].x+sphere.normal[i*2+1].x;
y := sphere.normal[i*2].y+sphere.normal[i*2+1].y;
z := sphere.normal[i*2].z+sphere.normal[i*2+1].z;

tav :=sqrt(sqr(x)+sqr(y)+sqr(z));
x := (x/tav)*(10+timer/blastspeedf[i]);
y := (y/tav)*(10+timer/blastspeedf[i]);
z := (z/tav)*(10+timer/blastspeedf[i]);

NewParticle(
x,y,z,
0,0,0,
1,1,1,
0.01,blast*0.6,cp,ct);

NewParticle(
x,y,z,
0,0,0,
1,1,0,
0.01,blast*1,cp,ct);

NewParticle(
x,y,z,
0,0,0,
1,1,0,
0.1,blast/10,cp,ct);

end;


for i := 0 to (sphere.vertices div 2)-1 do
begin
x := sphere.VERTEX[i*2].x;
y := sphere.vertex[i*2].y;
z := sphere.vertex[i*2].z;

tav :=sqrt(sqr(x)+sqr(y)+sqr(z));
x := (x/tav)*(10+timer/blastspeedv[i]);
y := (y/tav)*(10+timer/blastspeedv[i]);
z := (z/tav)*(10+timer/blastspeedv[i]);


NewParticle(
x,y,z,
0,0,0,
1,1,1,
0.01,blast*0.6,cp,ct);

NewParticle(
x,y,z,
0,0,0,
1,1,0,
0.01,blast*1,cp,ct);

NewParticle(
x,y,z,
0,0,0,
1,1,0,
0.1,blast/10,cp,ct);



end;
end;



gldisable(gl_lighting);

glloadidentity;
glcolor3f(1,1,1);

glbegin(gl_points);
	for i := 0 to 1000 do
	glvertex3f(stars[i].x,stars[i].y,stars[i].z);
glend;

glenable(gl_blend);
glblendfunc(gl_one,gl_one);

{$i renderparticles2.i};

// endscreen

glclear($100);
glorthoident;

glenable(gl_blend);
glblendfunc(gl_one,gl_one);
gldisable(gl_depth_test);
glbindtexture(gl_texture_2d,texts[22]);

glcolor3f(
(timer-7390)/10210,
(timer-7390)/10210,
(timer-7390)/10210);

drawsprite(0,0,0.5,0.08);

gldisable(gl_blend);
glenable(gl_depth_test);




end;








procedure RenderPart8(tmr:single);
var timer : single;
begin

timer := tmr+144900-113980;	


glclear($4100);
GlOrthoIdent;
glcolor3f(0.2,0.2,0.23);
gldisable(gl_texture_2d);
drawsprite(0,0,1,1);

glclear($100);
glenable(gl_normalize);

cameraposition.x := 26;//28*cos(-tmr*pi/180000);
cameraposition.y := 3*sin(-tmr*pi/18000);
cameraposition.z := 3*cos(tmr*pi/18000);
cameratarget.x :=0;
cameratarget.y :=0;
cameratarget.z :=0;


lpos[0] := cameraposition.x;
lpos[1] := cameraposition.y;
lpos[2] := cameraposition.z-10;

gllightfv(gl_light0,gl_position,@lpos[0]);

glenable(gl_lighting);
glenable(gl_light0);
glShadeModel(GL_SMOOTH);									// Select Smooth Shading
glMateriali(GL_FRONT, GL_SHININESS, 128);


glmatrixmode(gl_projection);
glloadidentity;
gluPerspective(70,4/3,0.1,50);


glulookat(
cameraposition.x,cameraposition.y,cameraposition.z,
cameratarget.x,cameratarget.y,cameratarget.z,0,0,1);


glmatrixmode(gl_modelview);

glenable(gl_depth_test);
glenable(gl_normalize);

cp.x := cameraposition.x;
cp.y := cameraposition.y;
cp.z := cameraposition.z;
ct.x := cameratarget.x;
ct.y := cameratarget.y;
ct.z := cameratarget.z;



glmatrixmode(gl_modelview);

for i := 0 to 40 do 
begin
glloadidentity;
gltranslatef(fighter[i].x,fighter[i].y,fighter[i].z);
glscalef(0.3,0.3,0.3);
gldrawobj(vadasz);
                                    

	tav := sqrt(
	sqr(fighter[i].x+(-fighter[i].x/100)*ffire[i])+
	sqr(fighter[i].y+(-fighter[i].y/100)*ffire[i])+
	sqr(fighter[i].z+(-fighter[i].z/100)*ffire[i]));

	if tav <> 0 then 
	if tav < 10 then begin
	                x := fighter[i].x+(-fighter[i].x/100)*ffire[i];
			y := fighter[i].y+(-fighter[i].y/100)*ffire[i];
			z := fighter[i].z+(-fighter[i].z/100)*ffire[i];

			x := (x /tav)*10.5;
			y := (y /tav)*10.5;
			z := (z /tav)*10.5;

			NewParticle(x,y,z,0,0,0,1,0,0,0.01,24*tav+random(24),cp,ct);
			NewParticle(x,y,z,0,0,0,1,1,0,0.01,16*tav+random(16),cp,ct);
			NewParticle(x,y,z,0,0,0,1,1,1,0.01,8*tav+random(8),cp,ct);
			end;


	NewParticle(
	fighter[i].x+(-fighter[i].x/100)*ffire[i],
	fighter[i].y+0.3+(-fighter[i].y/100)*ffire[i],
	fighter[i].z+(-fighter[i].z/100)*ffire[i],

	0,0,0,
	1,0,0,
	0.01,55,cp,ct);

	NewParticle(
	fighter[i].x+(-fighter[i].x/100)*ffire[i],
	fighter[i].y+0.3+(-fighter[i].y/100)*ffire[i],
	fighter[i].z+(-fighter[i].z/100)*ffire[i],
	0,0,0,
	1,1,1,
	0.05,4,cp,ct);

	NewParticle(
	fighter[i].x+(-fighter[i].x/100)*ffire[i],
	fighter[i].y-0.3+(-fighter[i].y/100)*ffire[i],
	fighter[i].z+(-fighter[i].z/100)*ffire[i],

	0,0,0,
	1,0,0,
	0.01,55,cp,ct);

	NewParticle(
	fighter[i].x+(-fighter[i].x/100)*ffire[i],
	fighter[i].y-0.3+(-fighter[i].y/100)*ffire[i],
	fighter[i].z+(-fighter[i].z/100)*ffire[i],
	0,0,0,
	1,1,1,
	0.05,4,cp,ct);


	NewParticle(
	fighter[i].x+0.16,
	fighter[i].y+0.1,
	fighter[i].z,
	0.01,0,0,
	1,1,0.2,
	0.2,0.2+random(10)/40,cp,ct);

	NewParticle(
	fighter[i].x+0.16,
	fighter[i].y-0.1,
	fighter[i].z,
	0.01,0,0,
	1,1,0.2,
	0.2,0.2+random(10)/40,cp,ct);




end;

for i := 0 to 10 do 
begin
glloadidentity;
gltranslatef(destroyer[i*2].x,destroyer[i*2].y,destroyer[i*2].z);
gldrawobj(rombolo);

	NewParticle(
	destroyer[i*2].x+(-destroyer[i*2].x/100)*dfire[i*2],
	destroyer[i*2].y+(-destroyer[i*2].y/100)*dfire[i*2],
	destroyer[i*2].z+(-destroyer[i*2].z/100)*dfire[i*2],
	destroyer[i*2].x/2000,destroyer[i*2].y/2000,destroyer[i*2].z/2000,
	0.1,0.1,0.1,
	0.4,3,cp,ct);

	NewParticle(
	destroyer[i*2].x+(-destroyer[i*2].x/100)*dfire[i*2],
	destroyer[i*2].y+(-destroyer[i*2].y/100)*dfire[i*2],
	destroyer[i*2].z+(-destroyer[i*2].z/100)*dfire[i*2],
	0,0,0,
	0,0,1,
	0.01,100+random(154),cp,ct);

	NewParticle(
	destroyer[i*2].x+(-destroyer[i*2].x/100)*dfire[i*2],
	destroyer[i*2].y+(-destroyer[i*2].y/100)*dfire[i*2],
	destroyer[i*2].z+(-destroyer[i*2].z/100)*dfire[i*2],
	0,0,0,
	1,1,1,
	0.01,128,cp,ct);


	tav := sqrt(sqr(destroyer[i*2].x+(-destroyer[i*2].x/100)*dfire[i*2])+
	sqr(destroyer[i*2].y+(-destroyer[i*2].y/100)*dfire[i*2])+
	sqr(destroyer[i*2].z+(-destroyer[i*2].z/100)*dfire[i*2]));

	if tav <> 0 then 
	if tav < 10 then begin
	                x := destroyer[i*2].x+(-destroyer[i*2].x/100)*dfire[i*2];
			y := destroyer[i*2].y+(-destroyer[i*2].y/100)*dfire[i*2];
			z := destroyer[i*2].z+(-destroyer[i*2].z/100)*dfire[i*2];

			x := (x /tav)*10.5;
			y := (y /tav)*10.5;
			z := (z /tav)*10.5;

			NewParticle(x,y,z,0,0,0,1,0,0,0.01,30*tav+random(30),cp,ct);
			NewParticle(x,y,z,0,0,0,1,1,0,0.01,20*tav+random(20),cp,ct);
			NewParticle(x,y,z,0,0,0,1,1,1,0.01,10*tav+random(10),cp,ct);
			end;




	NewParticle(
	destroyer[i*2].x+1,
	destroyer[i*2].y-0.31,
	destroyer[i*2].z-0.16,
	0.01,0,0,
	1,1,0.1,
	0.5,0.5+random(10)/40,cp,ct);


	NewParticle(
	destroyer[i*2].x+1,
	destroyer[i*2].y-0.12,
	destroyer[i*2].z-0.16,
	0.01,0,0,
	1,1,0.1,
	0.5,0.5+random(10)/40,cp,ct);

end;



for i := 0 to 40 do dfire[i] := (round(timer+dfirespeed[i]) mod 3000)/30;

for i := 0 to 40 do ffire[i] := (round(timer*2+dfirespeed[40-i]) mod 3000)/30;


glloadidentity;
glscalef(10,10,10);
gldrawobjfaced(spherep);


gldisable(gl_lighting);

glloadidentity;
glcolor3f(1,1,1);

glbegin(gl_points);
	for i := 0 to 1000 do
	glvertex3f(stars[i].x,stars[i].y,stars[i].z);
glend;

glenable(gl_blend);
glblendfunc(gl_one,gl_one);

{$i renderparticles2.i};


glclear($100);
glorthoident;

glenable(gl_blend);
glblendfunc(gl_one,gl_one);
gldisable(gl_depth_test);

glbindtexture(gl_texture_2d,texts[6+round(timer) div 2222]);

glcolor3f(
(round(timer) mod 2222)/4444,
(round(timer) mod 2222)/4444,
(round(timer) mod 2222)/4444);

drawsprite(-0.55,-0.9,0.4+sin(timer/10*pi/180)/80,0.06+sin(timer/10*pi/180)/80);
drawsprite(-0.55,-0.9,0.4+cos(timer/10*pi/180)/80,0.06+cos(timer/10*pi/180)/80);


glbindtexture(gl_texture_2d,texts[5+round(timer) div 2222]);


glcolor3f(
0.5-(round(timer) mod 2222)/4444,
0.5-(round(timer) mod 2222)/4444,
0.5-(round(timer) mod 2222)/4444);

if (5+round(timer) div 2222) >5 then 
drawsprite(-0.55,-0.9,0.4+sin(timer/10*pi/180)/80,0.06+sin(timer/10*pi/180)/80);
if (5+round(timer) div 2222) >5 then 
drawsprite(-0.55,-0.9,0.4+cos(timer/10*pi/180)/80,0.06+cos(timer/10*pi/180)/80);



gldisable(gl_blend);
glenable(gl_depth_test);

end;
